package com.hzs.system.sys.service;

import java.util.List;
import java.util.Map;

import com.hzs.common.domain.system.sys.SysRole;
import com.hzs.system.sys.param.SysRoleParam;
import com.hzs.system.sys.param.SysRoleQueryParam;

/**
 * 角色业务层
 *
 * @author hzs
 */
public interface ISysRoleService {

    /**
     * 根据条件分页查询角色数据
     *
     * @param param
     * @return
     */
    List<SysRole> selectRoleList(SysRoleQueryParam param);

    /**
     * 通过角色ID查询角色
     *
     * @param roleId 角色ID
     * @return 角色对象信息
     */
    SysRole selectRoleById(Long roleId);

    /**
     * 校验角色名称是否唯一
     *
     * @param param
     * @return
     */
    String checkRoleNameUnique(SysRoleParam param);

    /**
     * 校验角色权限是否唯一
     *
     * @param param
     * @return
     */
    String checkRoleKeyUnique(SysRoleParam param);

    /**
     * 校验角色是否允许操作
     *
     * @param roleId 角色ID
     */
    void checkRoleAllowed(Long roleId);

    /**
     * 通过角色ID查询角色使用数量
     *
     * @param roleId 角色ID
     * @return 结果
     */
    int countUserRoleByRoleId(Long roleId);

    /**
     * 新增保存角色信息
     *
     * @param param
     * @param userId
     * @return
     */
    int insertRole(SysRoleParam param, Long userId);

    /**
     * 修改保存角色信息
     *
     * @param param
     * @return
     */
    int updateRole(SysRoleParam param, Long userId);

    /**
     * 批量删除角色信息
     *
     * @param roleIds 需要删除的角色ID
     * @param userId
     * @return
     */
    int deleteRoleByIds(Long[] roleIds, Long userId);

    /**
     * 获取角色map
     *
     * @return
     */
    Map<Long, SysRole> getAllRoleMap();

    /**
     * 根据用户查询角色ID列表
     *
     * @param userId 用户ID
     * @return
     */
    List<Long> queryRoleIdListByUser(Long userId);

}
